# Class MultipartInput

java.lang.Object
org.apache.commons.fileupload2.core.MultipartInput

public final class MultipartInput extends Object
Low-level API for processing file uploads.

This class can be used to process data streams conforming to MIME 'multipart' format as defined in RFC 1867. Arbitrarily large amounts of data in the stream can be processed under constant memory usage.

The format of the stream is defined in the following way:

      multipart-body := preamble 1*encapsulation close-delimiter epilogue

      encapsulation := delimiter body CRLF

      delimiter := "--" boundary CRLF

      close-delimiter := "--" boundary "--"

      preamble := <ignore>

      epilogue := <ignore>

      body := header-part CRLF body-part

      header-part := 1*header CRLF

      header := header-name ":" header-value

      header-name := <printable ASCII characters except ":">

      header-value := <any ASCII characters except CR & LF>

      body-data := <arbitrary data>

Note that body-data can contain another mulipart entity. There is limited support for single pass processing of such nested streams. The nested stream is required to have a boundary token of the same length as the parent stream (see `setBoundary(byte[])`).

Here is an example of usage of this class:

    try {
        MultipartInput multipartStream = MultipartInput.builder()
                .setBoundary(boundary)
                .setInputStream(input)
                .get();
        boolean nextPart = multipartStream.skipPreamble();
        OutputStream output;
        while (nextPart) {
            String header = multipartStream.readHeaders();
            // process headers
            // create some output stream
            multipartStream.readBodyData(output);
            nextPart = multipartStream.readBoundary();
        }
    } catch (MultipartInput.MalformedStreamException e) {
        // the stream failed to follow required syntax
    } catch (IOException e) {
        // a read or write error occurred
    }

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`MultipartInput.Builder`
Builds a new `MultipartInput` instance.
`static class`
`MultipartInput.FileUploadBoundaryException`
Signals an attempt to set an invalid boundary token.
`class`
`MultipartInput.ItemInputStream`
An `InputStream` for reading an items contents.
`static class`
`MultipartInput.MalformedStreamException`
Signals that the input stream fails to follow the required syntax.
`static class`
`MultipartInput.ProgressNotifier`
Internal class, which is used to invoke the `ProgressListener`.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final byte`
`CR`
The Carriage Return ASCII character value.
`static final byte`
`DASH`
The dash (-) ASCII character value.
`static final int`
`DEFAULT_PART_HEADER_SIZE_MAX`
Default per part header size limit in bytes.
`static final byte`
`LF`
The Line Feed ASCII character value.

## Method Summary

Modifier and Type
Method
Description
`static MultipartInput.Builder`
`builder()`
Constructs a new `MultipartInput.Builder`.
`long`
`discardBodyData()`
Reads `body-data` from the current `encapsulation` and discards it.
`protected int`
`findByte(byte value, int pos)`
Searches for a byte of specified value in the `buffer`, starting at the specified `position`.
`protected int`
`findSeparator()`
Searches for the `boundary` in the `buffer` region delimited by `head` and `tail`.
`Charset`
`getHeaderCharset()`
Gets the character encoding used when reading the headers of an individual part.
`int`
`getMaxPartHeaderSize()`
Returns the per part size limit for headers.
`MultipartInput.ItemInputStream`
`newInputStream()`
Creates a new `MultipartInput.ItemInputStream`.
`long`
`readBodyData(OutputStream output)`
Reads `body-data` from the current `encapsulation` and writes its contents into the output `Stream`.
`boolean`
`readBoundary()`
Skips a `boundary` token, and checks whether more `encapsulations` are contained in the stream.
`byte`
`readByte()`
Reads a byte from the `buffer`, and refills it as necessary.
`String`
`readHeaders()`
Reads the `header-part` of the current `encapsulation`.
`void`
`setBoundary(byte[] boundary)`
Changes the boundary token used for partitioning the stream.
`void`
`setHeaderCharset(Charset headerCharset)`
Sets the character encoding to be used when reading the headers of individual parts.
`boolean`
`skipPreamble()`
Finds the beginning of the first `encapsulation`.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### CR

public static final byte CR
The Carriage Return ASCII character value.

See Also:
  - Constant Field Values

### LF

public static final byte LF
The Line Feed ASCII character value.

See Also:
  - Constant Field Values

### DASH

public static final byte DASH
The dash (-) ASCII character value.

See Also:
  - Constant Field Values

### DEFAULT_PART_HEADER_SIZE_MAX

public static final int DEFAULT_PART_HEADER_SIZE_MAX
Default per part header size limit in bytes.

Since:
  2.0.0-M4
See Also:
  - Constant Field Values

## Method Details

### builder

public static MultipartInput.Builder builder()
Constructs a new `MultipartInput.Builder`.

Returns:
  a new `MultipartInput.Builder`.

### discardBodyData

public long discardBodyData() throws MultipartInput.MalformedStreamException, IOException
Reads `body-data` from the current `encapsulation` and discards it.

Use this method to skip encapsulations you don't need or don't understand.

Returns:
  The amount of data discarded.
Throws:
  `MultipartInput.MalformedStreamException` - if the stream ends unexpectedly.
  `IOException` - if an i/o error occurs.

### findByte

protected int findByte(byte value, int pos)
Searches for a byte of specified value in the `buffer`, starting at the specified `position`.

Parameters:
  `value` - The value to find.
  `pos` - The starting position for searching.
Returns:
  The position of byte found, counting from beginning of the `buffer`, or `-1` if not found.

### findSeparator

protected int findSeparator()
Searches for the `boundary` in the `buffer` region delimited by `head` and `tail`.

Returns:
  The position of the boundary found, counting from the beginning of the `buffer`, or `-1` if not found.

### getHeaderCharset

public Charset getHeaderCharset()
Gets the character encoding used when reading the headers of an individual part. When not specified, or `null`, the platform default encoding is used.

Returns:
  The encoding used to read part headers.

### getMaxPartHeaderSize

public int getMaxPartHeaderSize()
Returns the per part size limit for headers.

Returns:
  The maximum size of the headers in bytes.
Since:
  2.0.0-M5

### newInputStream

public MultipartInput.ItemInputStream newInputStream()
Creates a new `MultipartInput.ItemInputStream`.

Returns:
  A new instance of `MultipartInput.ItemInputStream`.

### readBodyData

public long readBodyData(OutputStream output) throws MultipartInput.MalformedStreamException, IOException
Reads `body-data` from the current `encapsulation` and writes its contents into the output `Stream`.

Arbitrary large amounts of data can be processed by this method using a constant size buffer. (see `builder()`).

Parameters:
  `output` - The `Stream` to write data into. May be null, in which case this method is equivalent to `discardBodyData()`.
Returns:
  the amount of data written.
Throws:
  `MultipartInput.MalformedStreamException` - if the stream ends unexpectedly.
  `IOException` - if an i/o error occurs.

### readBoundary

public boolean readBoundary() throws FileUploadSizeException, MultipartInput.MalformedStreamException
Skips a `boundary` token, and checks whether more `encapsulations` are contained in the stream.

Returns:
  `true` if there are more encapsulations in this stream; `false` otherwise.
Throws:
  `FileUploadSizeException` - if the bytes read from the stream exceeded the size limits
  `MultipartInput.MalformedStreamException` - if the stream ends unexpectedly or fails to follow required syntax.

### readByte

public byte readByte() throws IOException
Reads a byte from the `buffer`, and refills it as necessary.

Returns:
  The next byte from the input stream.
Throws:
  `IOException` - if there is no more data available.

### readHeaders

public String readHeaders() throws FileUploadSizeException, MultipartInput.MalformedStreamException
Reads the `header-part` of the current `encapsulation`.

Headers are returned verbatim to the input stream, including the trailing `CRLF` marker. Parsing is left to the application.

TODO allow limiting maximum header size to protect against abuse.

Returns:
  The `header-part` of the current encapsulation.
Throws:
  `FileUploadSizeException` - if the bytes read from the stream exceeded the size limits.
  `MultipartInput.MalformedStreamException` - if the stream ends unexpectedly.

### setBoundary

public void setBoundary(byte[] boundary) throws MultipartInput.FileUploadBoundaryException
Changes the boundary token used for partitioning the stream.

This method allows single pass processing of nested multipart streams.

The boundary token of the nested stream is `required` to be of the same length as the boundary token in parent stream.

Restoring the parent stream boundary token after processing of a nested stream is left to the application.

Parameters:
  `boundary` - The boundary to be used for parsing of the nested stream.
Throws:
  `MultipartInput.FileUploadBoundaryException` - if the `boundary` has a different length than the one being currently parsed.

### setHeaderCharset

public void setHeaderCharset(Charset headerCharset)
Sets the character encoding to be used when reading the headers of individual parts. When not specified, or `null`, the platform default encoding is used.

Parameters:
  `headerCharset` - The encoding used to read part headers.

### skipPreamble

public boolean skipPreamble() throws IOException
Finds the beginning of the first `encapsulation`.

Returns:
  `true` if an `encapsulation` was found in the stream.
Throws:
  `IOException` - if an i/o error occurs.